public abstract class Koerper {

    private Punkt  p;
    private String farbe;

    public Koerper(Punkt p, String farbe) {
        this.p = p;
	this.farbe = farbe;
    }

    public Punkt gibPunkt() {
        return this.p;
    }

    public String gibFarbe() {
        return this.farbe;
    }

    public void setzeFarbe(String farbe) {
        this.farbe = farbe;
    }

    public void verschiebe(double xdelta, double ydelta, double zdelta) {
	this.p.verschiebe(xdelta,ydelta,zdelta);
    }

    public abstract void skaliere(double alpha);

    public abstract double berechneVolumen();

    public abstract double berechneOberflaeche();

    public abstract boolean enthaeltPunkt(Punkt p);

    public void drucke() {
        System.out.printf("Der Koerper befindet sich an Punkt: %f %f %f\n",
	    this.p.gibX(), this.p.gibY(), this.p.gibZ());
	System.out.printf("Sein Volumen betraegt: %f\n", this.berechneVolumen());
	System.out.printf("Seine Oberflaeche betraegt: %f\n", this.berechneOberflaeche());
	System.out.printf("Er hat die Farbe: %s\n", this.farbe);
    }
}
